/**
 	Gnowsis License 1.0
 	
 	Copyright (c) 2004, Leo Sauermann & DFKI German Research Center for Artificial Intelligence GmbH
 	All rights reserved.
 	
 	This license is compatible with the BSD license http://www.opensource.org/licenses/bsd-license.php
 	
 	Redistribution and use in source and binary forms,
/**
 	Gnowsis License 1.0
 	
 	Copyright (c) 2004, Leo Sauermann & DFKI German Research Center for Artificial Intelligence GmbH
 	All rights reserved.
 	
 	This license is compatible with the BSD license http://www.opensource.org/licenses/bsd-license.php
 	
 	Redistribution and use in source and binary forms,
 	with or without modification, are permitted provided
 	that the following conditions are met:
 	
 	    * Redistributions of source code must retain the above copyright notice,
 	      this list of conditions and the following disclaimer.
 	    * Redistributions in binary form must reproduce the above copyright notice,
 	      this list of conditions and the following disclaimer in the documentation
 	      and/or other materials provided with the distribution.
 	    * Neither the name of the DFKI nor the names of its contributors
 	      may be used to endorse or promote products derived from this software
 	      without specific prior written permission.
 	
 	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 	IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 	LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 	OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 	endOfLic**/
 	/*
 	 * Created on 28.08.2003
 	 */
 	package org.gnowsis.util;
 	
 	import java.io.PrintStream;
 	import java.io.PrintWriter;
 	
 	/**
 	 *
 	 * <p>Copyright: Copyright (c) 2003</p>
 	 * <p>Organisation: Gnowsis.com</p>
 	 * @author Leo Sauermann (leo@gnowsis.com)
 	 * @version $Id: GnowsisError.java,v 1.4 2004/09/09 15:38:29 kiesel Exp $
 	 */
 	public class GnowsisError extends RuntimeException {
 	        /**
 	         * Java 1.3.1 compability
 	         */
 	        private Throwable cause;
 	       
 	       
 	        public GnowsisError() {}
 	        public GnowsisError(String message) {
 	                super(message);
 	        }
 	        public GnowsisError(String message, Throwable cause) {
 	                super(message);
 	                this.cause = cause;
 	        }
 	 
 	        public GnowsisError(Throwable cause) {
 	                this("", cause);
 	        }
 	       
 	        public Throwable getCause() {
 	                return cause;
 	        }
 	
 	        public void printStackTrace( PrintStream s )    {
 	                if (cause != null)
 	                        cause.printStackTrace( s );
 	                super.printStackTrace( s );
 	        }
 	       
 	        public void printStackTrace( PrintWriter w ) {
 	                if (cause != null)
 	                        cause.printStackTrace( w );
 	                super.printStackTrace( w );
 	        }
 	
 	}
 	
 	
 	/*
 	 * $Log: GnowsisError.java,v $
 	 * Revision 1.4  2004/09/09 15:38:29  kiesel
 	 * - added CVS tags
 	 *
 	 */
