/*
 * Created on 17-Jun-2005
 * 
 */
package org.openrdf.jena;

import org.apache.log4j.Logger;
import org.openrdf.model.Resource;
import org.openrdf.model.Statement;
import org.openrdf.model.URI;
import org.openrdf.model.Value;

import info.aduna.collections.iterators.CloseableIterator;

import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.graph.Triple;
import com.hp.hpl.jena.util.iterator.ExtendedIterator;
import com.hp.hpl.jena.util.iterator.Filter;
import com.hp.hpl.jena.util.iterator.Map1;
import com.hp.hpl.jena.util.iterator.NiceIterator;

/**
 * @author wf
 * 
 */
public class ExtendedStatementIterator extends NiceIterator {
    
    private CloseableIterator<Statement> sesameIt;
    private Logger logger = Logger.getRootLogger();

    public ExtendedStatementIterator(CloseableIterator<Statement> stit) {
        sesameIt = stit;
    }
    
	/* (non-Javadoc)
	 * @see com.hp.hpl.jena.util.iterator.ExtendedIterator#removeNext()
	 */
	public Object removeNext() {
		Object obj = next();
        remove();
        return obj;
	}


	/* (non-Javadoc)
	 * @see com.hp.hpl.jena.util.iterator.ClosableIterator#close()
	 */
	public void close() {
		sesameIt.close();
	}

	/**
	 * 
	 * @see java.util.Iterator#remove()
	 */
	public void remove() {
		sesameIt.remove();
	}

	/* (non-Javadoc)
	 * @see java.util.Iterator#hasNext()
	 */
	public boolean hasNext() {
		boolean res=sesameIt.hasNext();
		if (!res) close();
		return res;
	}

	/* (non-Javadoc)
	 * @see java.util.Iterator#next()
	 */
	public Object next() {
		return statement2triple(sesameIt.next());
	}
    
    private Triple statement2triple(Statement stmt) {
    	//System.out.println(stmt);
        Node s, p, o;
        Resource subject = stmt.getSubject();
        URI predicate = stmt.getPredicate();
        Value object = stmt.getObject();
           
        s = ValueToNode.convert(subject);
        p = ValueToNode.convert(predicate);       
        o = ValueToNode.convert(object);
        
        logger.debug("\tSesame: " + stmt + "\n\tJena: " + s + ", " + p + ", " + o);
        return Triple.create(s, p, o);
    }

    public void finalize() {
    	//Hmm...
    	sesameIt.close();
    }

}
