/**
 * 
 */
package org.openrdf.jena;

import org.openrdf.repository.Repository;

import com.hp.hpl.jena.rdf.listeners.StatementListener;
import com.hp.hpl.jena.rdf.model.InfModel;
import com.hp.hpl.jena.rdf.model.impl.InfModelImpl;
import com.hp.hpl.jena.reasoner.InfGraph;
import com.hp.hpl.jena.reasoner.rulesys.GenericRuleReasoner;

/**
 * 
 * This class wraps a sesame repository as a jena InfModel
 * It handles bulkupdates efficiently in single Sesame transactions.
 * 
 * IT ONLY HANDLES FORWARD CHAINING REASONERS (cause this is all we need :) 
 * 
 * @author grimnes
 *
 */
public class InfModelSesame extends InfModelImpl implements InfModel {

	/**
	 * @param infgraph
	 */
	public InfModelSesame(InfGraph infgraph) {
		super(infgraph);
	}
	
	public static InfModelSesame create(Repository repository,GenericRuleReasoner reasoner) {
		InfGraph g = new InfGraphSesame(reasoner,reasoner.getRules(),null);
		g.rebind(new GraphSesame(repository));
        return new InfModelSesame(g);
	}

	public static InfModelSesame create(Repository repository,GenericRuleReasoner reasoner, StatementListener sl) {
		InfGraph g = new InfGraphSesame(reasoner,reasoner.getRules(),null);
		InfModelSesame res=new InfModelSesame(g);
		res.getDeductionsModel().register(sl);
		g.rebind(new GraphSesame(repository));
        return res;
	}
}
