package org.openrdf.jena;

import java.util.List;
import java.util.Vector;

import com.hp.hpl.jena.query.QuerySolution;
import com.hp.hpl.jena.query.ResultSet;

/**
 * @author Daniel Burkhart
 * 
 * Implements the ResultSet Interface, that is returned from several query
 * execution methods, e.g. in class QueryExecutionSesame
 */
public class ResultSetImpl implements ResultSet {
	private Vector data = new Vector();
	private int current = 0;
	
	/**
	 * the variable names for the projection
	 */
	private List resultVars = null;
	
	public ResultSetImpl(List resultVars) {
		super();
		this.resultVars = resultVars;
	}
	
	
	public void add(Object o) {
		data.add(o);
	}	

	public boolean hasNext() {
		if(current<data.size())
			return true;
		return false;
	}

	public Object next() {
		return data.get(current++);
	}

	public QuerySolution nextSolution() {
		return (QuerySolution) data.get(current++);
	}

	public int getRowNumber() {
		return current;
	}

	public List getResultVars() {
		return resultVars;
	}

	public boolean isOrdered() {
		return false;
	}

	public boolean isDistinct() {
		return false;
	}

	public void remove() {
		
	}
}
