package org.openrdf.jena;

import java.util.Iterator;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.gnowsis.util.GnowsisError;
import org.openrdf.repository.RepositoryConnection;
import org.openrdf.repository.RepositoryException;
//import org.openrdf.sesame.repository.Transaction;


import com.hp.hpl.jena.graph.Graph;
import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.graph.Triple;
import com.hp.hpl.jena.graph.impl.GraphWithPerform;
import com.hp.hpl.jena.graph.impl.SimpleBulkUpdateHandler;
import com.hp.hpl.jena.util.iterator.ExtendedIterator;

/**
 * This is a BulkUpdateHandler for Inf graphs - 
 * why it is different from the normal sesame bulkupdatehandler escapes me just now...
 * but there was a reason yesterday...
 * TODO: meditate on this and reach enlightenment.
 * 
 * @author grimnes
 *
 */
public class SesameInfBulkUpdateHandler extends SimpleBulkUpdateHandler  {
	
	protected static Logger log = 
		Logger.getLogger(SesameInfBulkUpdateHandler.class.getName());
	
	public SesameInfBulkUpdateHandler(GraphWithPerform graph) {
		super(graph);
	} 	

	@Override
	protected void add(List triples, boolean notify) {
		
		try {
			GraphSesame sesamegraph=(GraphSesame)graph;
			try {
				RepositoryConnection c = sesamegraph.repository.getConnection();
				c.setAutoCommit(false);
				//Transaction t=sesamegraph.getRepository().startTransaction();
				int j=0;
				for (Iterator i = triples.iterator(); i.hasNext(); ) {
					Triple trip = (Triple) i.next();
					c.add(sesamegraph.jena2sesame(trip));
					j++;
				}
				log.finest("Added "+j+" triples in ONE transaction. YEAH BABY list!");
				c.commit();
				c.close();
			} catch (RepositoryException e) {
				throw new GnowsisError("Couldn't create transaction",e);
			}
			if (notify) manager.notifyAddList( graph, triples );
		} catch (ClassCastException e) {
			super.add(triples, notify);
		}
	}

	@Override
	public void add(Graph g, boolean withReifications) {
		//TODO: ignore reification for now
		try {
			InfGraphSesame sesamegraph=(InfGraphSesame)graph;
			try {
				RepositoryConnection c = sesamegraph.repository.getConnection();
				c.setAutoCommit(false);
				//Transaction t=sesamegraph.repository.startTransaction();
				int j=0;
				for (ExtendedIterator ei=g.find(Node.ANY,Node.ANY,Node.ANY);ei.hasNext();) {
					Triple trip = (Triple)ei.next();
					c.add(sesamegraph.sesamegraph.jena2sesame(trip));
					j++;
					// add triple to the inf-engine
					sesamegraph.hackThisIntoEngine(trip);
				}
				log.finest("Added "+j+" triples in ONE transaction. YEAH BABY graph!");
				c.commit();
				c.close();
			} catch (RepositoryException e) {
				throw new GnowsisError("Couldn't create transaction",e);
			}
	        manager.notifyAddGraph( graph, g );
		} catch (ClassCastException e) {
			log.log(Level.FINE, "maybe fuckup: "+e, e);
			super.add(g, withReifications);
		}
	}
	

}

